<template>
    <v-data-table :headers="headers" :items="filteredList" sort-by="amount" class="elevation-1">
        <template v-slot:top>
            <template>
                <v-card>
                    <v-row class="mt-2 justify-left">

                        <v-spacer></v-spacer>
                        <v-spacer></v-spacer>
                    </v-row>
                </v-card>
            </template>
            <v-toolbar flat>
                <v-toolbar-title>My Stock</v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>

                <v-text-field v-model="search" append-icon="mdi-magnify" label="Search" single-line hide-details>
                </v-text-field>
                <v-dialog v-model="dialog" max-width="500px">
                    <template v-slot:activator="{ on, attrs }">
                        <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">
                            New Product
                        </v-btn>
                    </template>
                    <v-card>
                        <v-card-title>
                            <span class="text-h5">{{ formTitle }}</span>
                        </v-card-title>

                        <v-card-text>
                            <v-container>
                                <v-row>
                                    <v-col cols="12" sm="6" md="4">
                                        <v-text-field v-model="editedItem.name" label="Product Name"></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="4">
                                        <v-text-field v-model="editedItem.calories" label="Amount"></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-card-text>

                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="close"> Cancel </v-btn>
                            <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>

                <v-dialog v-model="dialogDelete" max-width="500px">
                    <v-card>
                        <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="closeDelete">Cancel</v-btn>
                            <v-btn color="blue darken-1" text @click="deleteItemConfirm">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-toolbar>
        </template>
        <template #[`item.status`]="{ item }">
      <v-avatar v-if="item.amount >= 100" color="green" size="18">
      </v-avatar>
      <v-avatar v-else-if="item.amount >= 60 && item.amount <= 100" color="pink" size="18">
      </v-avatar>

      <v-avatar v-else color="red" size="18">
      </v-avatar>

    </template>
        <template #[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil </v-icon>
            <v-icon small @click="deleteItem(item)"> mdi-delete </v-icon>
        </template>
        <template v-slot:no-data>
            <v-btn color="primary" @click="initialize"> Reset </v-btn>
        </template>
    </v-data-table>
</template>
  
<script>
export default {
  layout: "default4",
  data: () => ({
    search: "",
    dialog: false,
    dialogDelete: false,
    headers: [
      {
        text: "Product",
        align: "start",
        sortable: false,
        value: "name",
      },
      { text: "Amount of Stock", value: "amount" },
      { text: "Status", value: "status" },

      { text: "Actions", value: "actions", sortable: false },
    ],
    data: [
      {
        name: "Normal Coffee",
        amount: 100,
      },
      {
        name: "Cocoa",
        amount: 100,
      },
      {
        name: "Plastic Cup",
        amount: 100,
      },
      {
        name: "Plastic Covercup",
        amount: 100,
      },
      {
        name: "Straw",
        amount: 100,
      },
      {
        name: "Plastic Bag",
        amount: 100,
      },
      {
        name: "Paper",
        amount: 61,
      },
      {
        name: "Whip-Cream",
        amount: 20,
      },
      {
        name: "Arabica",
        amount: 20,
      },
      {
        name: "Vietnam Coffee",
        amount: 20,
      },
      {
        name: "Tea",
        amount: 0,
      },
      {
        name: "Glass Cover",
        amount: 0,
      },
      {
        name: "Paper Bag",
        amount: 0,
      },
    ],
    editedIndex: -1,
    editedItem: {
      name: '',
      amount: 0,
    },
    defaultItem: {
      name: '',
      amount: 0,
    },
  }),

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? 'New Item' : 'Edit Item';
    },
    filteredList() {
      return this.data.filter((items) => {
        return items.name.toLowerCase().includes(this.search.toLowerCase());
      });
    },

  },

  watch: {
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    async initialize() {
      await this.$axios.$get('http://localhost:1337/api/managers').then((res) => {
        this.data = res.data.data
      }).catch((err) => {
        console.error(err)
      })
    },

    editItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogDelete = true;
    },

    deleteItemConfirm() {
      this.data.splice(this.editedIndex, 1);
      this.closeDelete();
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.data[this.editedIndex], this.editedItem);
      } else {
        this.data.push(this.editedItem);
      }
      this.close();
    },
  },
}
</script>
